#!/bin/sh -e
#This script makes xdtv recording in DVD format
# $Id: xdtv_makedvd.sh,v 1.7 2005/05/29 16:35:33 alainjj Exp $
#script under GNU General Public License (see COPYING)

#needs mplayer-1.0pre7,mjpegtools,dvdauthor,toolame
#and the font arial.ttf in ~/.spumux/ for the subtitles

#CONFIG##################
ALANG=fr
SLANG=fr
STEREO=off #"on" or "off"
STD=pal #"pal" or "ntsc"
AUDIOBITRATE="" # default "-b 192"
VIDEOBITRATE="-q 10 -b 6000" # default "-q 8 -b 7500"
MOPTSSUP="-xvfmt yuv420"
AUDIOFREQ=48000
DIRIN=./recs
DIROUT=./DVD
###########################

if [ "$STD" = "ntsc" ]; then
   FPS=29.97
   WIDTH=720; HEIGHT=480
   #WIDTH=352; HEIGHT=240
else
   FPS=25
   WIDTH=720; HEIGHT=576
   #WIDTH=352; HEIGHT=288
fi

if [ "$1" = "record" ]; then
  mkdir -p $DIRIN
  shift
  xdtv -rec_width 400 -rec_height $HEIGHT -rec_fps $FPS \
    -ybar 0 -rec_stereo $STEREO -rec_filename $DIRIN/ \
    -rec_vcodec "FFMpeg Mpeg4" -rec_videobr 5000 \
    -rec_acodec UnCompressed -rec_audiofreq $AUDIOFREQ -nbufs 10 "$@"
  exit 0
fi

if [ ! -d $DIRIN ]; then
  echo "You should have recorded with \"$0 record\""
  echo "You can alternatively put the avi/sub files in the directory $DIRIN"
  exit 1
fi

rm -f stream.yuv audiodump.pcm
mkfifo stream.yuv audiodump.pcm

rm -rf $DIROUT
##############################################"
for i in $DIRIN/*.avi; do
MOPTS="-noautosub -noaspect -noframedrop -vo yuv4mpeg -ao pcm:nowaveheader:file=audiodump.pcm"
MOPTS="$MOPTS"
[ "$STEREO" = off ] && MOPTS="$MOPTS -channels 1"
mplayer -noframedrop -noaspect -vf scale=$WIDTH:$HEIGHT $MOPTS $i &
PID1=$!

MP2OPTS="-v 0 -f 8 -a 2 $VIDEOBITRATE"
[ "$STD" = ntsc ] && MP2OPTS="$MP2OPTS -F 4" #non-roundness of ntsc fps...
mpeg2enc -o video.mpg $MP2OPTS < stream.yuv &
PID2=$!

FREQ2=$(printf %d.%03d $(($AUDIOFREQ/1000)) $(($AUDIOFREQ%1000)))
TOOLAMEOPTS="$AUDIOBITRATE -s $FREQ2"
[ "$STEREO" = off ] && TOOLAMEOPTS="$TOOLAMEOPTS -m m"
(cat audiodump.pcm | toolame $TOOLAMEOPTS /dev/stdin audio.mpg) &
PID3=$!

wait $PID1
wait $PID2
wait $PID3

FILE="mplex -f 8 -o /dev/stdout audio.mpg video.mpg |"
#FILE="tcmplex -m d -o /dev/stdout -p audio.mpg -i video.mpg |"

DVDAUTHOPTS="--video 4:3 -a $ALANG+16bps"
[ "$STEREO" = off ] && DVDAUTHOPTS="${DVDAUTHOPTS}+1ch"

#creation of the subtitles:
SUB=$DIRIN/$(basename $i .avi).sub
if [ -s $SUB ] && [ $(wc -l < $SUB) -gt 2 ]; then
   tr '\n' '' < $SUB | sed 's/\([0-9]\)/\1/g' | tr -s '' | 
    tr '' '\n' | sed -e 's/^ *\([^ ]\(.*[^ ]\)\?\).*$/\1/' > aa.sub
   cat > script <<EOF
      <subpictures>
          <stream>
              <textsub filename="aa.sub" characterset="ISO8859-1" horizontal-alignment="center" font="arial.ttf"
             />
           </stream>
       </subpictures>
EOF
   FILE="$FILE spumux script |"
   DVDAUTHOPTS="$DVDAUTHOPTS -s $SLANG"
fi

#creation of dvd directory
dvdauthor $DVDAUTHOPTS -o $DIROUT -f "$FILE"
mkdir -p $DIROUT/data
[ -f "$SUB" ] && cp -pf $SUB $DIROUT/data
done
######################################################

dvdauthor -T -o $DIROUT
cp -f "$0" $DIROUT/data

echo "The directory $DIROUT is done."
echo "to test: mplayer -v -dvd-device $DIROUT dvd://1"
echo "to record on a disk: growisofs -Z /dev/dvdwriter -dvd-video $DIROUT"
#mkisofs -dvd-video $DIROUT | cdrecord -v dev=ATA:1,0,0 -
echo "after this, DO NOT FORGET TO REMOVE $DIRIN and $DIROUT"
